<?php
namespace Phppot;

use \Phppot\DataSource;

class Course
{

    private $dbConn;

    private $ds;

    function __construct()
    {
        require_once "DataSource.php";
        $this->ds = new DataSource();
    }

    function validateCourse($course_name, $course_amount)
    {
        $valid = true;
        $errorMessage = array();
        foreach ($_POST as $key => $value) {
            if (empty($_POST[$key])) {
                $valid = false;
            }
        }
            
		// Course name Validation
		if (empty($course_name)) 
             {
			
				$errorMessage[] = "Course name Required.";
				$valid = false;
			}
		
		//Course Amount Validation
		 
        if((empty($course_amount))|| !(is_numeric($course_amount)) )
        {	
			
			$errorMessage[] = 'Valid Course Amount Required.'; 
			$valid = false;
			
		}
		
        
        
        if ($valid == false) {
            return $errorMessage;
        }
        return;
    }



    function insertCourse($course_name, $course_amount,$status)
    {

        $query = "INSERT INTO course_details (name,amount,status) VALUES (?, ?, ?)";
        $paramType = "sss";
        $paramArray = array(
            $course_name,
            $course_amount,
			$status);
		//var_dump($paramArray);
        //exit();
        $insertId = $this->ds->insert($query, $paramType, $paramArray);
        return $insertId;
    }

    function ListCourseDetails()
    {
        $query = "select id,name,amount,case when status=0 then 'Inactive'
when status=1 then 'Active'
End as status FROM course_details";
        $paramType = "s";
        $paramArray = array();
        $courseDetails = $this->ds->select($query, $paramType, $paramArray);
        
        return $courseDetails;
    }

    function updateCourseDetails($status,$id)
	{
        if($status=='0')
        {
            $new_status=1;
           
        }
        if($status=='1')
        {
            $new_status=0;
        }
		$query = "update course_details set status=?  WHERE id = ?";
        $paramType = "ss";
        $paramArray = array($new_status,$id);
        $numrows=$this->ds->numRows($query, $paramType, $paramArray);
        
		//return $numrows;
		
	}
	
}
