<?php
namespace Phppot;

use \Phppot\DataSource;

class Member
{

    private $dbConn;

    private $ds;

    function __construct()
    {
        require_once "DataSource.php";
        $this->ds = new DataSource();
    }

    function validateMember()
    {
        $valid = true;
        $errorMessage = array();
        foreach ($_POST as $key => $value) {
            if (empty($_POST[$key])) {
                $valid = false;
            }
        }
            
		// Email Validation
		if (! isset($error_message)) {
			if (! filter_var($_POST["userEmail"], FILTER_VALIDATE_EMAIL)) {
				$errorMessage[] = "Invalid email address.";
				$valid = false;
			}
		}
		//Selected course validation
		if (! isset($error_message)) {	
			if(isset($_POST['courseId']) && $_POST['courseId'] == '0') { 
			$errorMessage[] = 'Please select a Course.'; 
			$valid = false;
			}
		}
		
		
		//Mobile number validation
		if (! isset($error_message)) {	
			if((empty($_POST['userMobile']))|| !(is_numeric($_POST['userMobile'])) ) { 
			$errorMessage[] = 'Please provide a valid mobile number.'; 
			$valid = false;
			}
		}

		//Name validation
		if (! isset($error_message)) {	
			if(empty($_POST['userName'])) { 
			$errorMessage[] = 'Please provide your Name.'; 
			$valid = false;
			}
		}
			
	
		//DoB validation
		if (! isset($error_message)) {	
			if(empty($_POST['dob'])) { 
			$errorMessage[] = 'Please provide your Date of Birth.'; 
			$valid = false;
			}
		}
			
		//Selected gender validation
		if (! isset($error_message)) {	
			if(isset($_POST['gender']) && $_POST['gender'] == '0') { 
			$errorMessage[] = 'Please select Gender.'; 
			$valid = false;
			}
		}			

	
		// Validation to check if Terms and Conditions are accepted
		if (! isset($error_message)) {
			if (! isset($_POST["terms"])) {
				$errorMessage[] = "Accept terms and conditions.";
				$valid = false;
			}
		}
        
        else {
            $errorMessage[] = "All fields are required.";
        }
        
        if ($valid == false) {
            return $errorMessage;
        }
        return;
    }

    function isMemberExists($username, $email)
    {
        $query = "select * FROM registered_users WHERE user_name = ? OR email = ?";
        $paramType = "ss";
        $paramArray = array($username, $email);
        $memberCount = $this->ds->numRows($query, $paramType, $paramArray);
        
        return $memberCount;
    }
	
	function loadCourseDetails()
    {
        $query = "select id,name,amount FROM course_details WHERE status = 1";
        $paramType = "s";
        $paramArray = array();
        $courseDetails = $this->ds->select($query, $paramType, $paramArray);
        
        return $courseDetails;
    }
	
	function loadCourseAmountDetails($courseid)
    {
        $query = "select amount FROM course_details WHERE status = 1 and id = ?";
        $paramType = "s";
        $paramArray = array($courseid);
        $courseDetails = $this->ds->select($query, $paramType, $paramArray);
        
        return $courseAmountDetails;
    }
	

	function isMemberLogin($username, $password)
    {
        $query = "select id,first_name FROM registered_users WHERE user_name = ? and password = ?";
        $paramType = "ss";
        $paramArray = array($username, $password);
        $memberDetails = $this->ds->select($query, $paramType, $paramArray);
         
	return $memberDetails;
	  
    }


	function updateTransactionDetails($transactionid,$transactionstatus,$registrationid)
	{
		$query = "update transaction_details set transactionid=?,transactionstatus=?  WHERE registrationid = ?";
        $paramType = "sss";
        $paramArray = array($transactionid,$transactionstatus,$registrationid);
        $numrows=$this->ds->numRows($query, $paramType, $paramArray);
		//return $numrows;
		
	}

	function loadTransactionDetails()
   	 {	
        	$query = 'SELECT (@row_number:=@row_number + 1) AS sr, t.username,
					t.email,
					t.mobilenumber,
					c.name AS cname,
					t.amount,
					t.transactionstatus,
					t.transactionid,
					t.transactiondate,
					t.gender,
					t.dob 
					FROM transaction_details t
					INNER JOIN course_details c ON c.id=t.courseid,
					(SELECT @row_number:=0) AS tx
					WHERE t.transactionstatus=1';
        	$paramType = "s";
        	$paramArray = array();
        	$transactionDetails = $this->ds->select($query, $paramType, $paramArray);
        
        	return $transactionDetails;
   	 }
	


	public function exportProductDatabase($productResult) {
        	$timestamp = time();
        	$filename = 'Export_excel_' . $timestamp . '.xls';

        	header("Content-Type: application/vnd.ms-excel");
        	header("Content-Disposition: attachment; filename=\"$filename\"");

        	$isPrintHeader = false;
        	foreach ($productResult as $row) {
            		if (! $isPrintHeader) {
                	echo implode("\t", array_keys($row)) . "\n";
                	$isPrintHeader = true;
           	 }
            	echo implode("\t", array_values($row)) . "\n";
       		 }
        	exit();
   	 }


    function insertMemberRecord($username, $mobile,$courseid, $email, $amount, $response,$gender,$dob)
    {
		date_default_timezone_set("Asia/KOLKATA");
        
        $query = "INSERT INTO transaction_details (username,email,mobilenumber,courseid,amount,transactionstatus,transactionid,
		registrationid,registrationurl,transactiondate,status,gender,dob) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
        $paramType = "sssssssssssss";
        $paramArray = array(
            $username,
            $email,
			$mobile,
            $courseid,
            $amount,
			'0',
			'tid',
			$response,
			'regurl',
			date("d-M-Y-h:i:sa"),
			'1',
			$gender,
			$dob	
        );
		var_dump($paramArray);
        $insertId = $this->ds->insert($query, $paramType, $paramArray);
        return $insertId;
    }
}
